-- fist code from midilooper.lua
help.title = "Midi Looper Multi Channel - Date: 2009/07/31"
help.author = "Vespa - Italy"
help.description = [=[
   Designed for: UC-33 (M-Audio/Evolution) preset 1
Goal: 3 Live Loops stored for each channel and controlled by UC-33:
 - for each Channels (2-8):
   - sliders 2-8 : Volume (CC7) 
   - knobs 10-16 : FX Selector for above knobs
 - slider 33 : Current Channel Selector
 - buttons 34, 35, 36: Rec Loop A, Loop B, Loop C
 - button 37: Delete current Channel
(host must be playing)
]=]

vprint(" \n"..help.title.." - "..help.author.." \n")
vprint(help.description)

--  USER SETTINGS:   -----------------------------------------------------------------------------------------------------------------------------------------------------------------
  -- CC that controls the Loop, for Button on-off use onSwitch, and a middle value is stored
	ccRecLoop    = {}
	ccRecLoop.A  = {cc = 14, onSwitch = true, value = 0.5 }
	ccRecLoop.B  = {cc = 15, onSwitch = true, value = 0.5 }
	ccRecLoop.C  = {cc = 16, onSwitch = true, value = 0.5 }
	ccDeleteLoop = {cc = 17, onSwitch = true, value = 0.5 }
	--[=[	About Rec Buttons A B C
	if not rec then press A or B or C, wait a noteOn to Rec in loop.temp,
	pattern_sel = last button pressed A, B or C (current Selected loop)
	if rec, pressing Del , clear loop.temp (REC aborted!)
	if rec, pressing (A,B,C) ,pattern_sel = last button,save loop.temp to Loop [pattern_sel](A,B,C)
	  -> may be different from the begin rec button, so you can choose where save at the end
	play pattern_sel
	
	if not rec, pressing Del , clear Loop [pattern_sel] 
	if not rec, pressing (A,B,C) ,patternChangeModeChoose decides when changing to (A,B,C)
	and it's ready to rec again (press Del to abort rec)
	]=]

	-- Pay Attention: VSTLua call midi channel from 0 to 15
  -- Current Channel Selector: cc, channel of controller,  divisions, from channel 2 (->2-1 = 1), listen chxx and process it, new current channel
	ChSelector = {cc = 28, ccch = 0, from = 1, to = 7, listen = 0, ch = 1 }

  -- Loop's features
	loops = { A={}, B={}, C={}, temp={} } -- Initialize - DON'T MODIFY THIS LINE - this will store the MIDI datastored ???? for saving
	loops["play_temp"] = true -- Let temp loop play
		menuSynchMode = {"EndsPoint", "HostSync"}
	loops["synchMode"] = 1 -- 0=EndsPoint (uses only samples) ; 1=HostSync (use hpst position ppqPos) ; ... 
	  -- In case of Host Sync:
		loops["loopLen"] = 16 -- Lenght in quarters
	
  -- FX Mapping in* ... out* 
	-- Look at Layout .png to understand what I mean
    -- Pay Attention: VSTLua call midi channel from 0 to 15 instead of 1 to 16
	-- the index is the channel
	-- the number of division is take by the count of the sub table in out_cc
	fxmap =  { }
	
--	fxmap.ch0.sel_cc = 10
--	fxmap.ch0.in_cc = {12,13}
--	fxmap.ch0.out_cc = {{0,10}, {1,11}, {12,13}, {14,15}, {123,120}}
	fxmap[1] = {}	-- CH 2
	fxmap[1].sel_cc = 10		-- FX selector
	fxmap[1].in_cc = {12,13}	-- input (now work only for 2 cc)
	fxmap[1].out_cc = {{0,10}, {1,11}, {12,13}, {14,15}, {123,120}} -- possibilities
	fxmap[1].cur_fx = 2  -- initialize the second pair of FXs {1,11}
	
	fxmap[2] = {}	-- CH 3
	fxmap[2].sel_cc = 10
	fxmap[2].in_cc = {12,13}
	fxmap[2].out_cc = {{0,10}, {1,11}, {12,13}, {14,15}, {123,120}}
	fxmap[2].cur_fx = 2  -- initialize 

	fxmap[3] = {}	-- CH 4
	fxmap[3].sel_cc = 10
	fxmap[3].in_cc = {12,13}
	fxmap[3].out_cc = {{0,10}, {1,11}, {12,13}, {14,15}, {123,120}}
	fxmap[3].cur_fx = 2  -- initialize 

	fxmap[4] = {}	-- CH 5
	fxmap[4].sel_cc = 10
	fxmap[4].in_cc = {12,13}
	fxmap[4].out_cc = {{0,10}, {1,11}, {12,13}, {14,15}, {123,120}}
	fxmap[4].cur_fx = 2  -- initialize 

	fxmap[5] = {}	-- CH 6
	fxmap[5].sel_cc = 10
	fxmap[5].in_cc = {12,13}
	fxmap[5].out_cc = {{0,10}, {1,11}, {12,13}, {14,15}, {123,120}}
	fxmap[5].cur_fx = 2  -- initialize 

	fxmap[6] = {}	-- CH 7
	fxmap[6].sel_cc = 10
	fxmap[6].in_cc = {12,13}
	fxmap[6].out_cc = {{0,10}, {1,11}, {12,13}, {14,15}, {123,120}}
	fxmap[6].cur_fx = 2  -- initialize 

	fxmap[7] = {}	-- CH 8
	fxmap[7].sel_cc = 10
	fxmap[7].in_cc = {12,13}
	fxmap[7].out_cc = {{0,10}, {1,11}, {12,13}, {14,15}, {123,120}}
	fxmap[7].cur_fx = 2  -- initialize 

	
--  END OF USER SETTINGS.   -----------------------------------------------------------------------------------------------------------------------------------------------------


-- INITIALISE other VARIABLES
-- 	DON'T MODIFY Variable with #
	loopempty = true --  #  when loop is = {}, so I hope to use less cpu
	loopmod = false --  #  loop has been modified
	loopNotesDown = {} -- # Manage what notes are down from the loop
	pattern_sel = "A"  -- Selected loop = last button pressed A, B or C
	pattern_prev = "" --   # previous loop
	pattern_cur  = "" --   # currrent loop, what is playing
	patternChangeModeChoose = {"wait a noteOn","next repeat","on the fly"} --  # 
	patternChangeModeCur = 3	-- inizialize the Change Mode
	firstloop = true  --  # 
	rec = false --  #  we're not recording
	recCC = 0  -- (1)=record CC in loop or (0)=by-pass CC
	PC_Keys = 0  -- (1) enable keys of PC instead of a MIDI Control Surface (experiment for QWERTY Keyboards)
	initKeyboadDone = false  --  # 

	curTime = 0			--  # 
	maxtime = (2^31)	--  # 

	framePos = {curIn=0, curOut=0, lastIn=0, lastOut=0, length=0} --  #  manage ppqPos of the Frame
	iter=1	--  # 

-- end initialise variables.

	tap = 0.5	--  # 0 or 1

-- includes
-- ScriptName: Global variable: full path of loaded script
-- cwd: current working directory, extract from ScriptName the path until last "\" character
cwd = ScriptName:sub(1, (ScriptName:len()-string.reverse(ScriptName):find("\\")+1) )
dofile(cwd.."table.save-0.94.lua")


function resetCb()
	panic()
end

function midiEventCb(event)
	ft("midiEventCb", 1)
	eventtosend = copyMidiEvent(event)  -- initialize the thru if nothing isn't modified
	
	--[=[
		dati x1 y1 x2 y2
		y = kappa*x + cost
		kappa = ( y2 - y1 ) / ( x2 - x1 )
		cost = y1 - kappa * x1
	]=]
	
	-- Channel Selector
	if event.type == midi.cc and event.byte2 == ChSelector.cc and event.channel==ChSelector.ccch  then
		-- Distribuite the new value of Selected Channel ( from -> to) on the 0-127
		-- like this mode:   2++3++++4++++5++++[...]++++[to-1]++[to]
		local x
		local div
		local start
		div = ChSelector.to - ChSelector.from + 1
		start = ChSelector.from
		x = start + ((event.byte3+1)/(128/(div-1))+0.49)\1 -- \1 divisione per intero is equivalent of VB: INT()
		-- debug vprint(x.."/n")
		if ChSelector.ch != x then
			Change_CH_SEL(x)
		end
		eventtosend = nil -- don't let the event go to midi out

	-- REC buttons
	elseif event.type == midi.cc and 
	(event.byte2 == ccRecLoop.A.cc or
	 event.byte2 == ccRecLoop.B.cc or
	 event.byte2 == ccRecLoop.C.cc ) then
		if event.byte2 == ccRecLoop.A.cc then
			pattern_sel = "A"
		elseif event.byte2 == ccRecLoop.B.cc then
			pattern_sel = "B"
		elseif event.byte2 == ccRecLoop.C.cc then
			pattern_sel = "C"
		end
		if ccRecLoop[pattern_sel].onSwitch == true then
			if ccRecLoop[pattern_sel].value != (event.byte3\64) then  -- button is swicthing?
				if rec == false then
					startRec()
				else
					stopRec()
				end
			end
		else
			-- toggle recording when cc  goes high
			if (event.byte3\64) == 1 and ccRecLoop[pattern_sel].value == (event.byte3\64) then
				startRec()
			else
				stopRec()
			end
		end
		ccRecLoop[pattern_sel].value = (event.byte3\64)
		eventtosend = nil -- don't let the event go to midi out

	-- CLEAR from Loop the Selected Channel
	elseif event.type == midi.cc and event.byte2 == ccDeleteLoop.cc then
		if ccDeleteLoop.onSwitch == true then
			-- button is swicthing?
			if event.byte3 != ccDeleteLoop.value then
				clearloop(ChSelector.ch)
			end
		else
			-- toggle cleaning when cc goes high
			if event.byte3 == 127 then
				clearloop(ChSelector.ch)
			end
		end
		ccDeleteLoop.value = (event.byte3\64)
		eventtosend = nil -- don't let the event go to midi out

	-- TAP! tempo by UC33 0button (cc 18) and send to  Loopy Llama vst for Tap! Tempo (Loopy Llama listens on ch1, cc 25 by default)
	-- !!! BPM of loopy is like 118.350 bpm like step by step!! ->> it's not good! :(
	elseif event.type == midi.cc and event.byte2 == 18 then
		Tap(event)
	
	-- here future denvelopments
	-- elseif... XX
	

	-- otherwise...   IF  RECORDING  --> ADDTOLOOP
	elseif event.channel==ChSelector.listen then-- -????
		copyevent = copyMidiEvent(event)
		copyevent.channel = ChSelector.ch
		eventtosend = copyMidiEvent(copyevent)
		if rec == true then
			if loopempty then
				curTime = 0
				vprint("REC ON \n")
				if loops.synchMode==1 then
					loopInPos = curHostTime.ppqPos
					loopOutPos = loopInPos + loops.loopLen
				end				
			end
			if not(event.type == midi.cc and recCC==0) then
				-- vprint("adding... ")
				addToLoop(copyevent)
			end
		end

	--  MIDI THRU   modify	
	elseif event.channel!=ChSelector.listen then
		-- FX MAP  ?????? quelli in loop non vanno
		reMapFX(event)

	end  -- proseguire con i elseif all'altezza di XX per modifiche

	--  MIDI THRU send
	if eventtosend then --  nil (null) == "False"
		if event.channel != ChSelector.listen or not(rec and syncMode==0 and loops.play_temp ) then
			sendMidi(eventtosend) -- and echo through... both in recocording true/false , and CC????
		end
		-- else the event is played suddently (if syncMode==0) by loops.play_temp
	end
	ft("midiEventCb")
end

function onFrameCb()
	ft("midiEventCb", 1)
	-- for not calculating a bunch of variables,
	-- to extimate the ppqPos of the End of the current Frame , I extrapolate by the last frame
	framePos.lastIn  = framePos.curIn
	framePos.lastOut = framePos.curOut
	-- refresh values
	framePos.curIn  = curHostTime.ppqPos
	framePos.length = framePos.curIn - framePos.lastIn
	framePos.curOut = framePos.curIn + framePos.length -- it's a prevision, may not be exactly
	-- check and find forwards/rewinds to previous errors ???
	
	-- calc  factor (for " * " )  to transform a distance in pos -> to samples
	posToSamples = VSTFrameLength/framePos.length    -- in samples/pos
	
  if not loopempty then
	-- process between last out < =   -->  < cur out
	if loops.synchMode==1 then
		loopAdvancePos()
	elseif loops.synchMode==0 then
		loopAdvanceSample(VSTFrameLength, curHostTime)
	end
  end
	ft("midiEventCb")
end

function Change_CH_SEL(x)
	ChSelector.ch = x
	vprint("Selected CH = "..(ChSelector.ch+1).." \n")
	guiSetLabel(LcurCH, ""..(ChSelector.ch+1), 0)
	
    -- Having x1, y1, x2, y2
	local x1 = ChSelector.from
	local y1 = 0 -- min value of knob
	local x2 = ChSelector.to
	local y2 = 1 -- max value of knob
	-- y = kappa*x + cost
	-- where
	local kappa = ( y2 - y1 ) / ( x2 - x1 )
	local cost  = y1 - kappa * x1
	
	guiSetValue(gui_CH_SEL, kappa*x + cost)
end

function startRec()
	ft("startRec", 1)
	rec = true
	vprint("Recording \n")
	guiSetLabel(Lrec, "Recording", 0)
	if loopempty then
		vprint("Loop is empty: REC begin at next event \n")
		firstloop = true -- to check the stop and Leght
		pattern_cur = pattern_sel -- set pattern
	end
	fLoopChange()
	ft("startRec")
end

function stopRec()
	ft("stopRec", 1)
	rec = false
	vprint("Stopped \n")
	guiSetLabel(Lrec, "Stopped", 0)

	if firstloop then
		vprint("it was firstloop \n")
		if loops.synchMode == 0 then
			maxtime = curTime
		end
		curTime = 0
		firstloop = false
		pattern_cur = pattern_sel -- set pattern
	end

	for i, v in ipairs(loops.temp) do 
		table.insert(loops[pattern_sel], v)
	end
	-- SORT events
	table.sort(loops[pattern_sel], compair)
	fLoopChange()
	clearNotesDown()
	loopmod = false
	loops.temp = {}
	ft("stopRec")
end

function fLoopChange() -- Manage change between A,B,C
	if  pattern_prev != pattern_sel and not firstloop then
		if patternChangeModeCur==1 then
			clearNotesDown()
		
		elseif patternChangeModeCur==2 then
			clearNotesDown()
		elseif patternChangeModeCur==3 then -- on the fly
			pattern_cur = pattern_sel -- set pattern
			clearNotesDown()
		end
	end
	pattern_prev = pattern_sel
end

function toggleSynchMode(request)
	if firstloop and not rec and (request!=loops.synchMode) then
		loops.synchMode=request
		-- GUI ... ???
	else
		vprint("Error: Stop and clear all before toggle loops.synchMode")
		-- GUI ... ???
	end
end

function addToLoop(event) -- insert a new event into the buffer
	ft("addToLoop", 1)
	if loopempty then
		-- calculate how many decimal taking for precision
		if curHostTime.tempo<100 then -- 100 bmp, I made calc in excel, 
			recPrecision = 3 -- decimali
		else
			recPrecision = 2 -- decimali
		end
		loopempty = false
	end
	if loops.synchMode==0 then  -- based on sample
		table.insert(loops.temp, {curTime+event.delta, event})
	end
	if loops.synchMode==1 then -- save as host Time Position
		local pos
		pos = round((curHostTime.ppqPos%loops.loopLen), recPrecision)
		table.insert(loops.temp, {pos, event}) -- ??? insert unsortly
	end
	loopmod=true -- loop has been modified
	ft("addToLoop")
end

function clearloop(channel)
	ft("clearloop", 1)
	clearNotesDown(channel)
	loops.temp = {}
	local looplocal
	looplocal = {}
	
	if rec then
		rec = false
		vprint("REC aborted ! \n")
		guiSetLabel(Lrec, "aborted !", 0)
		if firstloop then
			loopempty = true -- when loop is = {}, so I hope to use less cpu
			curTime = 0
			maxtime = (2^31)
		end
	else
		if loopempty then
			vprint("LOOP already EMPTY ! \n")
		else
			vprint("CLEAR CH: "..(channel+1)..": ")
			local counter = 0
			for i, v in ipairs(loops[pattern_sel]) do 
				--  print("start i: "..i.." \n")
				m = loops[pattern_sel][i][2]
				if m.channel != channel then
					table.insert(looplocal, v)
				else
					counter = counter+1
				end
			end
			if counter == 0 then
				vprint(" already clean \n")
			else
				vprint(" cleared "..counter.." events \n")
				loops[pattern_sel] = {}
				if #looplocal>0 then
					for i, v in ipairs(looplocal) do
						table.insert(loops[pattern_sel], v)
					end		
				else
					loopempty = true
					vprint("LOOP EMPTY again! \n")
					-- re-init values
					firstloop = true
					rec = false -- we're not recording
					curTime = 0
					maxtime = (2^31)
				end
			end
		end
	end
	
	ft("clearloop")
end

function clearNotesDown(channel)
	ft("clearNotesDown", 1)
	--if loopmod or firstloop then --???? clean only necessary
		-- copy from: midi.lua - stopAllPlaying()
		-- clear all playing notes
		for i, v in pairs(loopNotesDown) do
			notedown = i % 128
			channeldown = math.floor(i / 128)
			if channeldown == channel then
				for j=1,loopNotesDown[i] do	-- send many noteoff as many note
					sendMidi(noteOff(notedown, channeldown, j*10)) -- note, channel, delta
				end
			end
			if not channel then -- channel is nil, process all
				for j=1,loopNotesDown[i] do	-- send many noteoff as many note
					sendMidi(noteOff(notedown, channeldown, j*10)) -- note, channel, delta
				end
			end
		end
	--end
	ft("clearNotesDown")
end

function reMapFX(event)	-- FX MAP
	ft("reMapFX", 1)
	-- FX Selector
	if event.type == midi.cc and event.byte2 == fxmap[event.channel].sel_cc  then
		-- Distribuite
		local xx
		local div
		local start
		div = #fxmap[event.channel].out_cc
		start = 1
		xx = start + ((event.byte3+1)/(128/(div -1))+0.49)\1 -- \1 division per interger is equivalent of VB: INT()
		-- debug vprint(xx.."/n")
		if fxmap[event.channel].cur_fx != xx then
			fxmap[event.channel].cur_fx = xx
			vprint("Selected FX for CH "..(event.channel+1).." : "..(table.concat(fxmap[event.channel].out_cc[xx], " ")).." \n")
		end
		eventtosend = nil -- don't let the event go to midi out
		
	-- FX re-assign FX1
	elseif event.type == midi.cc and event.byte2 == fxmap[event.channel].in_cc[1] then
		local cur_fx
		cur_fx = fxmap[event.channel].cur_fx
		
		copyevent = copyMidiEvent(event)
		copyevent.byte2 = fxmap[event.channel].out_cc[cur_fx][1]
		eventtosend = copyMidiEvent(copyevent)
		
	-- FX re-assign FX2  (idem)
	elseif event.type == midi.cc and event.byte2 == fxmap[event.channel].in_cc[2] then
		local cur_fx
		cur_fx = fxmap[event.channel].cur_fx
		
		copyevent = copyMidiEvent(event)
		copyevent.byte2 = fxmap[event.channel].out_cc[cur_fx][2]
		eventtosend = copyMidiEvent(copyevent)
	end
	ft("reMapFX")
end

function Tap(event)	-- TAP TEMPO
	if event!=nil then	-- from MIDI Controller
		if tap != (event.byte3\64) then  -- button is swicthing?
			tap = (event.byte3\64)
			copyevent = copyMidiEvent(event)
		end
	else	-- from PC keyboard
		if tap!=1 then 
			tap=1 
		else 
			tap=0
		end
		local e = {}
        e.type=11	-- controller
		e.channel, e.byte2, e.byte3, e.byte4, e.delta, e.noteOffset, e.noteLength, e.detune, e.noteOffVelocity = 0
		e.sysex = ""
		copyevent = completeMidiFields(e)
	end
	vprint(" Tap! ")

	copyevent.byte2 = 25 -- CC x Loopy Lama
	copyevent.byte3 = 127 -- value
	
	sendMidi(copyevent)
	-- then schedule its reset after
	copyevent.byte3 = 0
	copyevent.delta = copyevent.delta + 200 --  like about a 32th @ 250bpm   -- VSTSampleRate/((curHostTime.tempo*2)/60)
	scheduleEvent(copyevent)
	
end

function loopAdvanceSample(samples, hosttime)
	ft("loopAdvanceSample", 1)
	for i, v in ipairs(loops[pattern_cur]) do
		t = v[1] --   -mintime
		m = v[2]
		-- play correct notes
		if t>= curTime and t<curTime+samples then
			c = copyMidiEvent(m)
			c.delta = t-curTime
			scheduleEvent(c)
		end
	end

	-- I do the same for loops.temp
	if loops.play_temp then
		for i, v in ipairs(loops.temp) do
			t = v[1] --   -mintime
			m = v[2]
			-- play correct notes
			if t>= curTime and t<curTime+samples then
				c = copyMidiEvent(m)
				c.delta = t-curTime
				scheduleEvent(c)
			end
		end
	end

-- loop back to zero
	if curTime>maxtime then
		vprint("-- Loop -- > \n")
		-- vprint("curTime:"..curTime.." maxtime:"..maxtime.."  loop-- > \n")
		curTime = maxtime-curTime -- ????
	end

	curTime = curTime + samples -- before or after ????
	ft("loopAdvanceSample")
end

function loopAdvancePos()
	ft("loopAdvancePos", 1)
	local posFrom
	local posTo
	local formula
	posFrom = framePos.lastOut % loops.loopLen -- % is modulo
	posTo   = framePos.curOut  % loops.loopLen
	
	if posFrom < posTo then -- compair the positions and detect loop back
		formula = 0 -- normal
	else
		formula = 1 -- loop back will append
	--	vprint("- Loop ->")
		
		if loopmod then  -- e se lo sposto in AddToLoop() ??
			-- SORT events
			table.sort(loops[pattern_cur], compair)
			if loops.play_temp then table.sort(loops.temp, compair) end  -- ???? incasina?
			loopmod=false
		end
	end

	for i, v in ipairs(loops[pattern_cur]) do
		t = v[1]
		m = v[2]
		c = {} -- delete c
		pass = false -- pass event
		-- play correct notes
		if formula == 0 then
			if posFrom <= t and t < posTo then  -- use AND
				c = copyMidiEvent(m)
				pass=true
			end
		end
		if formula == 1 then
			if posFrom <= t or t < posTo then   -- use OR, because loop will restart in this frame
				c = copyMidiEvent(m)
				pass=true
			end
		end
		if pass then -- check if there is an event to proces   not(c==nil)
			--   calculate new delta  (samples from current frame)
			if posFrom<=t then
				c.delta = round((t-posFrom) * posToSamples)
			else	-- loop is restart :    from|-------R--t----------|to
				c.delta = round(((t+loops.loopLen)-posFrom) * posToSamples)
				-- vprint("t > From !\n")
			end
			
			--	Manage notes are playing from loop (like outputNotesDown and sendMidi(event)  from midi.lua  )
			local byte2_ch = c.byte2+128*c.channel
			--record which notes are currently down
			if c.type==midi.noteOn then
				if not loopNotesDown[byte2_ch] then -- if it's first time...
					loopNotesDown[byte2_ch] = 1 -- byte2 = note; byte3 = velocity
				else
					loopNotesDown[byte2_ch] = loopNotesDown[byte2_ch] +1	--increment count
				end
			end
			if c.type==midi.noteOff then
				if loopNotesDown[byte2_ch] then -- if exist
					loopNotesDown[byte2_ch] = loopNotesDown[byte2_ch] -1	--decrement count
				
					if loopNotesDown[byte2_ch]==0 then
						loopNotesDown[byte2_ch] = nil
					end
				end
			end
			
			 sendMidi(c)
			-- scheduleEvent(c)
		end
		if formula == 0 and posTo < t then  -- it's no necessary going on, loop is sorted
			break
		end
	end

	-- I do the same for loop.temp
	if loops.play_temp then
	  for i, v in ipairs(loops.temp) do
		t = v[1]
		m = v[2]
		c = {} -- delete c
		pass = false -- pass event
		-- play correct notes
		if formula == 0 then
			if posFrom <= t and t < posTo then  -- use AND
				c = copyMidiEvent(m)
				pass=true
			end
		end
		if formula == 1 then
			if posFrom <= t or t < posTo then   -- use OR, because loop will restart in this frame
				c = copyMidiEvent(m)
				pass=true
			end
		end
		if pass then -- check if there is an event to proces   not(c==nil)
			--   calculate new delta  (samples from current frame)
			if posFrom<=t then
				c.delta = round((t-posFrom) * posToSamples)
			else	-- loop is restart :    from|-------R--t----------|to
				c.delta = round(((t+loops.loopLen)-posFrom) * posToSamples)
				-- vprint("t > From !\n")
			end
			
			--	Manage notes are playing from loop (like outputNotesDown and sendMidi(event)  from midi.lua  )
			local byte2_ch = c.byte2+128*c.channel
			--record which notes are currently down
			if c.type==midi.noteOn then
				if not loopNotesDown[byte2_ch] then -- if it's first time...
					loopNotesDown[byte2_ch] = 1 -- byte2 = note; byte3 = velocity
				else
					loopNotesDown[byte2_ch] = loopNotesDown[byte2_ch] +1	--increment count
				end
			end
			if c.type==midi.noteOff then
				if loopNotesDown[byte2_ch] then -- if exist
					loopNotesDown[byte2_ch] = loopNotesDown[byte2_ch] -1	--decrement count
				
					if loopNotesDown[byte2_ch]==0 then
						loopNotesDown[byte2_ch] = nil
					end
				end
			end
			
			 sendMidi(c)
			-- scheduleEvent(c)
		end
		if formula == 0 and posTo < t then  -- it's no necessary going on, loop is sorted
			break
		end
	  end
	end

	ft("loopAdvancePos", 1)
end

function compair(a, b) -- used to sort tables
    return b[1]>a[1]         
end 

function round(num, idp)
    local mult = 10^(idp or 0)
    return math.floor(num * mult + 0.5) / mult
end

ftt = {}
function ft(fName, isStart) -- Function Time: manage and print how much time require a function
	--se la funzione  chimata con uno start, memorizza lo start, richiamando la fuinzione senza start si intende che  finita
	local totT
	if isStart then
		ftt[fName] = os.clock()
	else
		totT = os.clock() - ftt[fName]
		if totT > 0.01 then	-- filter
			vprint(fName.." used "..totT.." sec /n")
		end
	end
end

-- GUI
function openCb()
-- I see in same case openCb() run two times... so I use this "IF" to resolve bug
if not gui_CH_SEL then -- if the gui_... not exist

	local xx -- colonne
	local yy -- righe
	xx = 20
	yy = 50
	
	-- redefine Sizes  - Doesn't work
	-- GUISizes[GUITypes.menu].width = 100
	-- vprint(GUISizes[GUITypes.menu].width)
	
	--[=[  example
	setVSTParameter(0, smoothval) -- default value
    guiSetValue(gui_smooth, getVSTParameter(0))
	
    newcontrol = {x=xx*3, y=5, type=GUITypes.label,  label="curCH" }
    labelCurCH = guiAddControl(newcontrol)
		]=]

	newcontrol = {x=19, y=32, type=GUITypes.label, label="<-- GUI" }
    label = guiAddControl(newcontrol)
	label = nil
	
    newcontrol = {x=50, y=3, type=GUITypes.knob, label="CH_Sel", min=0, max=1 } -- ? NON VA CON 2 E 8
    gui_CH_SEL = guiAddControl(newcontrol)   

    newcontrol = {x=50+16, y=3+32+15, type=GUITypes.label, label=""..ChSelector.ch+1 }
    LcurCH = guiAddControl(newcontrol)
	
	newcontrol = {x=120, y=15, type=GUITypes.label, label="REC" }
    labelREC = guiAddControl(newcontrol)
	
	newcontrol = {x=125, y=15+10, type=GUITypes.label, label="init" }
    Lrec = guiAddControl(newcontrol)
	
    newcontrol = {x=170, y=5, type=GUITypes.onOffButton, label="synchMode"}
    LsynchMode_B = guiAddControl(newcontrol)
	guiSetValue(LsynchMode_B, loops.synchMode) -- initialize	
    newcontrol = {x=170+14, y=5+40, type=GUITypes.label, label=""..menuSynchMode[loops.synchMode+1]}
    LsynchMode = guiAddControl(newcontrol)
	
    newcontrol = {x=5, y=80, type=GUITypes.onOffButton, label="Rec CC", value=recCC}
    gui_rec_cc = guiAddControl(newcontrol)
	
    newcontrol = {x=55, y=80, type=GUITypes.onOffButton, label="PC Keys", value=PC_Keys}
    gui_PC_Keys = guiAddControl(newcontrol)	

    newcontrol = {x=155, y=100, type=GUITypes.kickButton,  label="Load Loop"}
    fileload = guiAddControl(newcontrol)

    newcontrol = {x=205, y=100, type=GUITypes.kickButton,  label="Save Loop"}
    filesave = guiAddControl(newcontrol)
	
    newcontrol = {x=25, y=150, type=GUITypes.text, label="Loop file name for saving"}
    filename = guiAddControl(newcontrol)
--    newcontrol = {x=xx*1, y=yy*2, type=GUITypes.onOffButton,  label="CH_2"}
--    CH_2 = guiAddControl(newcontrol)
--    newcontrol = {x=xx*1, y=yy*3, type=GUITypes.onOffButton,  label="CH_3"}
--	CH_3 = guiAddControl(newcontrol)
--    newcontrol = {x=xx*1, y=yy*4, type=GUITypes.onOffButton,  label="CH_4"}
--    CH_4 = guiAddControl(newcontrol)
--    newcontrol = {x=xx*1, y=yy*5, type=GUITypes.onOffButton,  label="CH_5"}
--    CH_5 = guiAddControl(newcontrol)
--    newcontrol = {x=xx*1, y=yy*6, type=GUITypes.onOffButton,  label="CH_6"}
--    CH_6 = guiAddControl(newcontrol)
--    newcontrol = {x=xx*1, y=yy*7, type=GUITypes.onOffButton,  label="CH_7"}
--    CH_7 = guiAddControl(newcontrol)
--    newcontrol = {x=xx*1, y=yy*8, type=GUITypes.onOffButton,  label="CH_8"}
--    CH_8 = guiAddControl(newcontrol)
	tLoopLen= {4,8,16,32,44,48,64,80,96,128}
	newcontrol = {x=5, y=210, type=GUITypes.menu,  label="Loop Length", menu=tLoopLen }
    menuLoopLen = guiAddControl(newcontrol)
	guiSetValue(menuLoopLen, 3 -1) -- initialize
	
	newcontrol = {x=5, y=270, type=GUITypes.menu,  label="Loop Change Mode", menu=patternChangeModeChoose }
    menuLoopChangeMode = guiAddControl(newcontrol)
	guiSetValue(menuLoopChangeMode, patternChangeModeCur -1) -- initialize
    
	-- show the result?
	--vuctrl= guiAddControl{x=150, y=5, type=GUITypes.vuMeter, label="out"}
    
    guiSetSize({width=250,height=350})

else
print (".......")
end
end

function valueChangedCb(tag, value, text)
	if tag==gui_CH_SEL then  
		--vprint(value)
		local x
		local div
		local start
		div = ChSelector.to - ChSelector.from + 1
		start = ChSelector.from
		x = start + (((value*127)-1)/(128/(div-1))+0.49)\1 -- \1 divisione per intero is equivalent of VB: INT()
		-- debug vprint(x.."/n")
		if ChSelector.ch != x then
			Change_CH_SEL(x)
		end
        --setVSTParameter(1, value)  
    end
	if tag==menuLoopLen then
		loops.loopLen = tLoopLen[value+1]
	end
	if tag==menuLoopChangeMode then
		patternChangeModeCur = (value+1) -- start from 0
	end	
    if tag==LsynchMode_B then
        loops.synchMode = value
		guiSetLabel(LsynchMode, ""..menuSynchMode[loops.synchMode+1], 0)
    end
	if tag==gui_rec_cc then
		recCC = value
	end
	if tag==gui_PC_Keys then
		PC_Keys = value
		if not initKeyboadDone then
			initKeyboad()
		end
	end
    if tag==fileload and value==1 then
        --sfilename = openFileSelector("*.*")
        if sfilename and #sfilename >0 then
			if file_exists(cwd..sfilename) then
				loops = table.load( cwd..sfilename )
				vprint("You load "..cwd..sfilename.."\n")
			else
				vprint(cwd..sfilename.." non trovato! \n")
			end
        else
            vprint("insert the name of file before save!\n")
        end
    end
	if tag==filename then
		sfilename=text
	end
    if tag==filesave and value==1 then
        if sfilename and #sfilename >0 then
            table.save(loops, cwd..sfilename)
			vprint("You save in  "..cwd..sfilename.."\n")
        else
            vprint("insert the name of file before save!\n")
        end
    end
end

-- Return true if file exists and is readable.
function file_exists(path)
  local file = io.open(path, "rb")
  if file then file:close() end
  return file ~= nil
end

function initKeyboad()
	initKeyboadDone = true
	function keyCb(key)
		if PC_Keys==1 then
			local sKey = string.char(key.character)
			if key.virtual==0 and key.modifier==0 then
				if key.down==1 then
				
					-- 2 to 8 for ChSelector.ch
					if 50<=key.character and key.character<=56 then
						if ChSelector.ch != sKey-1 then
							Change_CH_SEL(sKey-1)
						end
						
					-- REC LOOP in A,B,C
					elseif sKey=="a" or sKey=="b" or sKey=="c" then
						pattern_sel = string.upper(sKey)
						if rec == false then
							startRec()
						else
							stopRec()
						end

					-- Delete Loop with D
					-- I tried to use Del button but I found a lot of problems
					elseif sKey=="d" then
						clearloop(ChSelector.ch)
						
					-- TAP tempo with T
					elseif sKey=="t" then
						Tap(nil)
						
					end
				end
				
			-- OLD: Delete Loop with Del
			--elseif key.character==46 and key.virtual==22 and key.down==1 and key.modifier==0 then -- key.virtual is !=0
				--clearloop(ChSelector.ch)
			
			else
				vprint(keyName(key).." pressed!\n")
				print (key)
			end
			
			return true
		end
	end
	
end
